#include "HideButton.h"
#include <QDebug>
HideButton::HideButton( QWidget *parent )
        :QWidget( parent ),
        m_icon( new QIcon( ":/images/quit.png" ) ),
        pressed( false ),
        mouseOver( false )
{
}

void HideButton::paintEvent( QPaintEvent * )
{
    QPixmap px = m_icon->pixmap( 16, 16, ( pressed && mouseOver ) ? QIcon::Selected : QIcon::Normal );
    QPainter p( this );
    p.setWindow( 0, 0, 16, 16 );
    p.drawPixmap( 0, 0, px );
}

void HideButton::mousePressEvent( QMouseEvent *e )
{
    if ( e->button() == Qt::LeftButton )
    {
        pressed = true;
        mouseOver = true;
        update();
    }
}

void HideButton::mouseReleaseEvent( QMouseEvent *e )
{
    if ( e->button() == Qt::LeftButton )
    {

        if ( mouseOver )
            emit clicked();

        mouseOver = false;
        pressed = false;
        update();
    }

}

void HideButton::mouseMoveEvent( QMouseEvent *e )
{
    QPoint p( e->pos() );
    int x( p.x() );
    int y( p.y() );

    if ( x < 0 || x > 16 || y < 0 || y > 16 )
        mouseOver = false;
    else
        mouseOver = true;

    update();
}