#include "Applet.h"
#include <QtGui>
#include <QApplication>
#include "QtSingleApplication/qtsingleapplication.h"

int main( int argc, char *argv[] )
{
//     if ( QApplication::setStyle("oxygen") == 0 )

//    QApplication app( argc, argv );
    QtSingleApplication app( "UbuDSL_Applet", argc, argv );

    if (app.isRunning())
    {
        qDebug("Application is already running...");
        return 0;
    }

    QTextCodec::setCodecForCStrings( QTextCodec::codecForName( "UTF-8" ) );

#if QT_VERSION >= 0x040400
    app.setApplicationName( "UbuDSL Applet" );
    app.setApplicationVersion( "1.0.0" );
#endif

    QString translatorFileName = QLatin1String( "UbuDSL_Applet_" );
    translatorFileName += QLocale::system().name();

    QTranslator *translator = new QTranslator( &app );

    if ( !translator->load( translatorFileName, UBUDSL_PREFIX + "/share/ubudsl/translations/" ) )
    {
        qDebug() << "Failed to load the"
                 << QString( UBUDSL_PREFIX + "/share/ubudsl/translations/" + translatorFileName + "!" );
    }

    app.installTranslator( translator );

    QSettings palette( ":palette.ini", QSettings::IniFormat );
    app.setPalette( palette.value( "palette" ).value<QPalette>() );

    if ( !app.arguments().contains( "--no-delay" ) )
    {
        QRegExp delayRegExp( "^--?delay=(\\d+)$" );
        int delay = 2000; // by default 2s

        foreach ( QString argument, app.arguments() )
        {
            if ( delayRegExp.exactMatch( argument ) )
            {
                if ( delayRegExp.cap( 1 ).toInt() >= 0 && delayRegExp.cap( 1 ).toInt() <= 20 )
                {
                    delay = delayRegExp.cap( 1 ).toInt() * 1000;
                }

                break;
            }
        }

        QTimer::singleShot( delay, &app, SLOT( quit() ) );
        app.exec();
    }

    Applet w;
    w.show();

    app.connect( &app, SIGNAL( lastWindowClosed() ), &app, SLOT( quit() ) );
    app.connect( &w, SIGNAL( quit() ), &app, SLOT( quit() ) );

    return app.exec();
}
