/*
 * File: Globals.cpp
 * Author: Adrian Łubik (2008)
 * License: GNU LGPL v3
 */

#include "Globals.h"
#include <QDir>
#include <QFileInfo>

bool debugToFile = false;
bool debug = false;
FILE *pFile = stderr;

const QString UBUDSL_PREFIX( QString( PKG_PREFIX ).remove(  "\"" ) );

void setDebug( bool set, const QString fileName )
{
    if ( fileName.isEmpty() )
    {
        pFile = stderr;
        debugToFile = false;
    }
    else
    {
        QFileInfo fileInfo( fileName );
        QDir logDir( fileInfo.absolutePath() );

        if ( !logDir.exists() )
            logDir.mkpath( fileInfo.absolutePath() );

        pFile = fopen( fileName.toLatin1().constData(), "w" );

        if ( pFile == NULL )
        {
            pFile = stderr;
            debugToFile = false;
        }
        else
        {
            debugToFile = true;
        }
    }
    debug = set;
}
