/*
 * File: PackageManager.h
 * Author: Adrian Łubik (2008)
 * License: GNU LGPL v3
 */

#ifndef PACKAGEMANAGER_H
#define PACKAGEMANAGER_H

#include <QObject>
class QString;
class QStringList;
class QThread;

/**
  * An abstract base class for subclasses that implement a package manager support.
  */
class PackageManager: public QObject
{
    Q_OBJECT
public:
    PackageManager( QThread *parent = 0 );
    virtual ~PackageManager();

    virtual int installPackages( const QStringList &pkgs ) = 0;
    virtual int addCD( const QString &mntPoint ) = 0;
    virtual bool getIsPackageInstalled( const QString &pkg ) = 0;
    virtual bool getArePackagesAvailable( const QStringList &pkgs ) = 0;
    virtual QStringList getNotInstalled( const QStringList pkgs ) = 0;
};

#endif
