#include <QWidget>
#include <QPainter>
#include <QString>
#include <QEventLoop>
#include <QTimer>
#include <QLabel>

class Table : public QWidget
{
    Q_OBJECT
public:
    Table( QWidget *parent = 0 );
    qreal getOpacity()
    {
        return op;
    }
    bool isHidden()
    {
        return m_hidden;
    }
    bool isShown()
    {
        return !m_hidden;
    }
    QString text()
    {
        return lbl->text();
    }
public slots:
    void move( int x, int y )
    {
        QWidget::move( x, y );
    }
    void setVisible( bool visible, bool instantly = false );
    void show()
    {
        setVisible( true );
    }
    void hide()
    {
        setVisible( false );
    }
    void setText( QString t );
protected:
    void paintEvent( QPaintEvent *event );
private slots:
    void fadeIn();
    void fadeOut();
private:
    qreal op;
    QTimer *timer;
    bool m_hidden;
    QLabel *lbl;
signals:
    void hidden();
    void shown();
};
