#ifndef DISCONNECTTHREAD_H_
#define DISCONNECTTHREAD_H_

#include <QThread>
#include <QByteArray>
#include <QString>
#include <QSettings>
#include <QObject>
#include <QStringList>
#include <QNetworkInterface>
#include <QProcess>
#include <QTimer>
#include <QEventLoop>

#include "Globals.h"


class DisconnectThread: public QThread
{
    Q_OBJECT
public:
    DisconnectThread( QSettings *settings, QString( *fGetInterface )() );
    virtual ~DisconnectThread();

    void setShowMessage( bool show = true );

public slots:
    void run();

private:
    void removePidFiles( const QString &killedIface = "ppp0" );

    QString( *getInterface )();

    QSettings *m_settings;
    bool m_showMessage;

signals:
    void finished( bool showMessgage );
};

#endif /*CONNECTTHREAD_H_*/
